class HostParser

  self::HOST_VALIDITY_REGEX = %r'\A(?<subdomains>(?:\w+\.)*?)(?<domain>\w+\.\w{2,5})\z'.freeze

  def initialize(host)
    @host = host
  end

  def domain
    @host[send(:class)::HOST_VALIDITY_REGEX]

    return nil if $~.blank?

    match_hash = $~.names.inject({}){|mem, capture| mem[capture] = $~[capture]; mem}

    return match_hash["domain"]
  end

end
